freeslot("SKINCOLOR_CFIGHTER", "S_PLAY_CFSWITCH", "sfx_clswtc", "sfx_cldone", "SPR_CLSW")
sfxinfo[sfx_clswtc].caption = "Switching..."
sfxinfo[sfx_cldone].caption = "Switch complete"


skincolors[SKINCOLOR_CFIGHTER] = {
	name = "Clone Fighter",
	ramp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31},
	invcolor = SKINCOLOR_CRIMSON,
	invshade = 3, 
	chatcolor = V_GRAYMAP,
	accessible = true
}

states[S_PLAY_CFSWITCH] = {
        sprite = SPR_CLSW,
        frame = FF_ANIMATE,
        tics = -1,
        nextstate = S_PLAY_JUMP
}

local primaryRamp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31}
local secondaryRamp = {0,2,4,6,8,10,12,14,16,18,20,22,24,26,29,31}

addHook("ThinkFrame", function()
	if leveltime % 2 == 1 then
		skincolors[SKINCOLOR_CFIGHTER].ramp = secondaryRamp
	else
		skincolors[SKINCOLOR_CFIGHTER].ramp = primaryRamp
	end
end)

-- I/O stuff begins here - Take it away, Sz_!
--script was written by LJ & gained permission to post it

local function writeCvar(file, cvarname, player)
	local c = player.nextCv
	if cvarname == "clone_switchprev" then c = player.prevCv end
	file:write(c, "\n")
end

local function saveConfig(configname, player)
	-- Open the file ("w" means we will write data to it)
	local file = io.openlocal(configname, "w")

	if file then
		writeCvar(file, "clone_switchnext", player)
		writeCvar(file, "clone_switchprev", player)

		file:close() -- We're done, close the file now
	else
		print(configname.." not found.")
	end
end

local function loadConfig(configname, player)
	-- Open the file ("r" means we will read data from it)
	local file = io.openlocal(configname, "r")

	if file then
		player.nextCv = file:read("*n")
		player.prevCv = file:read("*n")

		file:close() -- We're done, close the file now
	else
		print(configname.." not found.")
	end
end

local buttonValues = {
	weaponnext = 1,
	weaponprev = 2,
	firenormal = 3,
	tossflag = 4,
	custom1 = 5,
	custom2 = 6,
	custom3 = 7
}
local buttonNames = {
	"Weapon Next",
	"Weapon Previous",
	"Fire Normal",
	"Toss Flag",
	"Custom 1",
	"Custom 2",
	"Custom 3",
}
COM_AddCommand("clone_switchnext", function(player, button)
	if gamestate != GS_LEVEL then
		CONS_Printf(player, "\x85".."ACCESS DENIED\x80 - This can only be used in a level.")
		return
	end
	
	if not button then
		CONS_Printf(player, "\x82".."clone_switchnext\x86 (int/string)\x80 - Change the button corresponding to Clone Fighter's \x87Next Character\x80 button.")
		return
	elseif not buttonValues[string.lower(button)]
	and (not tonumber(button) or (tonumber(button) < 1 or tonumber(button) > 7)) then
		CONS_Printf(player, "\x85INVALID BUTTON\x80 - Available options: WeaponNext (1) WeaponPrev (2) FireNormal (3) TossFlag (4) Custom1 (5) Custom2 (6) Custom3 (7)")
		return
	end
	
	local num
	if tonumber(button) then
		num = tonumber(button)
	else
		num = buttonValues[string.lower(button)]
	end
	
	if num == player.prevCv then
		CONS_Printf(player, "\x85".."ALREADY BOUND\x80 - Your \x87Previous Character\x80 button is already bound to \x83"..buttonNames[num]..".")
		return
	elseif num == player.nextCv
		CONS_Printf(player, "\x85".."ALREADY BOUND\x80 - Your \x87Next Character\x80 button is already bound to \x83"..buttonNames[num]..".")
		return
	else
		player.nextCv = num
		saveConfig("client/cfButtons.dat", player)
		CONS_Printf(player, "Your \x87Next Character\x80 button is now \x83"..buttonNames[num]..". A reminder of what it is can be seen on the HUD.")
	end
end)
COM_AddCommand("clone_switchprev", function(player, button)
	if gamestate != GS_LEVEL then
		CONS_Printf(player, "\x85".."ACCESS DENIED\x80 - This can only be used in a level.")
		return
	end
	
	if not button then
		CONS_Printf(player, "\x82".."clone_switchprev\x86 (int/string)\x80 - Change the button corresponding to Clone Fighter's \x87Previous Character\x80 button.")
		return
	elseif not buttonValues[string.lower(button)]
	and (not tonumber(button) or (tonumber(button) < 1 or tonumber(button) > 7)) then
		CONS_Printf(player, "\x85INVALID BUTTON\x80 - Available options: WeaponNext (1) WeaponPrev (2) FireNormal (3) TossFlag (4) Custom1 (5) Custom2 (6) Custom3 (7)")
		return
	end
	
	local num
	if tonumber(button) then
		num = tonumber(button)
	else
		num = buttonValues[string.lower(button)]
	end
	
	if num == player.nextCv then
		CONS_Printf(player, "\x85".."ALREADY BOUND\x80 - Your \x87Next Character\x80 button is already bound to \x83"..buttonNames[num]..".")
		return
	elseif num == player.prevCv
		CONS_Printf(player, "\x85".."ALREADY BOUND\x80 - Your \x87Previous Character\x80 button is already bound to \x83"..buttonNames[num]..".")
		return
	else
		player.prevCv = num
		saveConfig("client/cfButtons.dat", player)
		CONS_Printf(player, "Your \x87Previous Character\x80 button is now \x83"..buttonNames[num]..". A reminder of what it is can be seen on the HUD.")
	end
end)

addHook("PlayerSpawn", function(player)
	loadConfig("client/cfButtons.dat", player)
end)

addHook("GameQuit", function()
	if not consoleplayer then return end
	saveConfig("client/cfButtons.dat", consoleplayer)
end)